<div class="container">
  <h2>Peer Review</h2>
    <div *ngIf="editorReview">
      <h5>requested by editor: {{editorReview.user?.username}}</h5>
    </div>
  <div *ngIf="peerReview$ | async as peerReview">
    <div class="row">
      <div *ngIf="peerReview" class="col-9"><h3>Publication: {{peerReview.publication!['artefact'].object.name}}</h3>
      </div>
      <div class="col-3"><h3>Status:{{getStatusKey(status)}}</h3></div>
    </div>
    <h5>author: {{peerReview.publication!['artefact'].object.user?.username}}</h5>
    <div class="mb-3">
      <label for="formControlID" class="form-label">ID</label>
      <input [(ngModel)]="peerReview.id" type="number" class="form-control" id="formControlID" placeholder="#">
    </div>
    <div *ngIf="editorReview" class="mb-3">
      <label for="formControlArtefactSnapshot" class="form-label">Artefact to review</label>
      <a [href]="editorReview.artefact_snapshot" target="_blank" class="form-control" id="formControlArtefactSnapshot">{{peerReview.publication!['artefact'].object.name}} ({{getFileName(editorReview.artefact_snapshot)}})</a>
    </div>
    <div *ngIf="peerReview.report">
      <label for="formControlReport" class="form-label">Review Report</label>
            <a [href]="peerReview.report" class="form-control" id="formControlReport" target="_blank">{{getFileName(peerReview.report)}}</a>
    </div>


    <!--    <div class="btn-toolbar float-end" role="toolbar" aria-label="Toolbar with button groups">-->

    <div [ngSwitch]="status">
        <ng-template #sendReportModal let-modal>
          <div class="modal-header">
            <h4 class="modal-title" id="send-report-modal">{{modalTitle}}<span *ngIf="editorReview &&  editorReview.user"> to: {{editorReview.user.username}}</span></h4>
            <button type="button" class="btn-close" aria-label="Close" (click)="modal.dismiss('Cross click')"></button>
          </div>
          <div class="modal-body">
            <app-message-form [attachFile]="true" [recipient]="editorReview?.user" (value)="onMessage($event, modal)"></app-message-form>
          </div>
        </ng-template>

        <ng-template #messageModal let-modal>
          <div class="modal-header">
            <h4 class="modal-title" id="message-modal">{{modalTitle}} <span *ngIf="editorReview &&  editorReview.user"> to: {{editorReview.user.username}}</span></h4>
            <button type="button" class="btn-close" aria-label="Close" (click)="modal.dismiss('Cross click')"></button>
          </div>
          <div class="modal-body">
            <app-message-form [recipient]="editorReview?.user" (value)="onMessage($event, modal)"></app-message-form>
          </div>
        </ng-template>

      <ng-container *ngSwitchCase="Status.SENT">
        <button  type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModal, accept, 'Acceptance message')">Accept</button>
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModal, reject, 'Rejection message')">Reject</button>
      </ng-container>
      <ng-container *ngSwitchCase="Status.REVIEW_ACCEPTED" >
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(sendReportModal, complete, 'Send review report')">Complete</button>
      </ng-container>
      <ng-container *ngSwitchCase="Status.REJECTED">
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModal, accept, 'Reopening message')">Reopen</button>
      </ng-container>
      <ng-container *ngSwitchDefault>
        <div>
          <i>no action at that stage</i>
        <br>
        <b>But DEBUG ACTION</b>
        </div>
        <button type="button" class="btn btn-primary me-3 mb-3" (click)="do(messageModal, accept, 'Reopening message')">Reopen</button>

      </ng-container>

      <ngb-accordion #acc="ngbAccordion" activeIds="ngb-panel-0">
        <ngb-panel title="Review logs">
          <ng-template ngbPanelContent>
            <app-review-log [object]="reviewLog"
                            *ngFor="let reviewLog of peerReview.review_logs">
            </app-review-log>
          </ng-template>
        </ngb-panel>
      </ngb-accordion>

    </div>

  </div>
</div>
